#ifndef _GHASHER_H_
#define _GHASHER_H_
struct GHApp{
	GtkWidget *window;
	GtkWidget *fileentry;
	GtkWidget *progress;
	GtkWidget *hashlabel;
	GtkWidget *sumentry;
	GtkWidget *actionbutton;
	GtkWidget *filebutton;
	GtkWidget *digestdropdown;//treat as a GtkWidget only, it's diffrent on gtk2.2 vs gtk 2.4
	const gchar *digesttype;
	const gchar *cmdfilename;
};

struct ActionButton{
	const gchar *const name;
	gboolean (*callback)(GtkButton *button,struct GHApp *app);
};

struct SumContext {
	struct GHApp *app;
	EVP_MD_CTX ctx;
	const EVP_MD *md;
	int currentfile;
	struct stat statbuf;
	off_t read_acc;
	gboolean allok;
};

void show_error_dialog(struct GHApp *app,const gchar * message, ...);
char *hex_dump(const unsigned char in[], int len, char out[], int max);
#endif

